var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
define(["require", "exports", "system_lib/Feed", "system/SimpleFile", "system_lib/Metadata"], function (require, exports, feed, SimpleFile_1, Metadata_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Visitors2 = void 0;
    var Item = (function () {
        function Item(starts, inProgress, firstName, lastName, city, company) {
            this.starts = dateToTimeOfDay(starts);
            this.inProgress = inProgress;
            this.firstName = firstName;
            this.lastName = lastName;
            this.city = city;
            this.company = company;
        }
        __decorate([
            Metadata_1.field("Event start time"),
            __metadata("design:type", String)
        ], Item.prototype, "starts", void 0);
        __decorate([
            Metadata_1.field("Event has started"),
            __metadata("design:type", Boolean)
        ], Item.prototype, "inProgress", void 0);
        __decorate([
            Metadata_1.field("Given name"),
            __metadata("design:type", String)
        ], Item.prototype, "firstName", void 0);
        __decorate([
            Metadata_1.field("Surname"),
            __metadata("design:type", String)
        ], Item.prototype, "lastName", void 0);
        __decorate([
            Metadata_1.field("The company the fisitor work for"),
            __metadata("design:type", String)
        ], Item.prototype, "company", void 0);
        __decorate([
            Metadata_1.field("The city the visitor is from"),
            __metadata("design:type", String)
        ], Item.prototype, "city", void 0);
        return Item;
    }());
    function dateToTimeOfDay(date) {
        return twoDigits(date.getHours()) + ':' + twoDigits(date.getMinutes());
    }
    function twoDigits(num) {
        var result = num.toString();
        if (result.length === 1)
            result = '0' + result;
        return result;
    }
    function setTime(date, timeStr) {
        var parts = timeStr.split(':');
        var hours = parseInt(parts[0]);
        var minutes = parseInt(parts[1]);
        if (isNaN(hours) || hours < 0 || hours > 23)
            console.warn("Invalid hours", timeStr);
        else
            date.setHours(hours);
        if (isNaN(minutes) || minutes < 0 || minutes > 59)
            console.warn("Invalid miutes", timeStr);
        else
            date.setMinutes(minutes);
        date.setSeconds(0);
        date.setMilliseconds(0);
        return date;
    }
    var Visitors2 = (function (_super) {
        __extends(Visitors2, _super);
        function Visitors2(env) {
            var _this = _super.call(this, env) || this;
            _this.establishFeed(new Collection("visitors"));
            return _this;
        }
        return Visitors2;
    }(feed.Feed));
    exports.Visitors2 = Visitors2;
    var Collection = (function () {
        function Collection(feedName) {
            this.listType = Item;
            this.itemType = Item;
            this.name = feedName;
        }
        Collection.prototype.getList = function (spec) {
            var _this = this;
            var fileName = "CSVList.csv";
            return SimpleFile_1.SimpleFile.readCsv(fileName).then(function (data) { return ({
                items: _this.gotData(data)
            }); }, function (error) { return console.error(fileName, "not found", error); });
        };
        Collection.prototype.gotData = function (csvList) {
            var result = [];
            var now = new Date();
            for (var _i = 0, csvList_1 = csvList; _i < csvList_1.length; _i++) {
                var csvItem = csvList_1[_i];
                var nowTime = now.getTime();
                var startTime = setTime(new Date(nowTime), csvItem.startTime);
                var endTime = setTime(new Date(nowTime), csvItem.endTime);
                console.log("End", endTime.toString(), csvItem.lastName);
                if (endTime.getTime() > nowTime) {
                    result.push(new Item(startTime, startTime.getTime() < nowTime, csvItem.firstName, csvItem.lastName, csvItem.city, csvItem.company));
                }
            }
            ;
            this.items = result;
            return result;
        };
        Collection.prototype.getDetails = function (spec) {
            return Promise.resolve(this.items[spec.index]);
        };
        return Collection;
    }());
});
